package com.jdbernard.timeanalyzer

import org.joda.time.DateTime
import org.joda.time.Duration
import org.joda.time.format.PeriodFormat
import org.joda.time.format.PeriodFormatter

public class Event implements Cloneable {

    public final String description
    public final String notes
    public final DateTime start
    public Duration duration    // bit of a hack, allows modification for the
                                // TimelineEventProcessor

    public static PeriodFormatter periodFormatter = PeriodFormat.getDefault()

    public Event(String desc, String notes, DateTime start, Duration duration) {
        this.description = desc
        this.notes = notes
        this.start = start
        this.duration = duration
    }

    public Event(Map params) {
        this.description = params.description ?: ""
        this.notes = params.notes ?: ""
        this.start = params.start 
        this.duration = params.duration
    }

    public Event(Map params, Event e) {
        this.description = params.description ?: e.description
        this.notes = params.notes ?: e.notes
        this.start = params.start ?: e.start
        this.duration = params.duration ?: e.duration
    }

    public String toString() { return description }

}
