package com.jdbernard.timeanalyzer

public class TwoLevelCategorizationPlan implements CategorizationPlan {

    private static final def TWO_LEVEL_PATTERN = ~/(.+?):(.*)/

    public boolean deservesNewCategory(Event event, List<Event> el) {
        return event ==~ TWO_LEVEL_PATTERN
    }

    public Category newCategory(Event event, List<Event> el) {
        def m = event.description =~ TWO_LEVEL_PATTERN
        return new TwoLevelCategory(m[0][1])
    }

    public List<Event> findEventsToRecategorize(Event event,
    List<Event> existingEvents) {
        def m = event.description =~ TWO_LEVEL_PATTERN
        return existingEvents.findAll { it.description ==~ /${m[0][1]}:.*/ }
    }
}
